const objectHash = require('object-hash');

const verifySignature = require('./verify-signature');
const { forum } = require('./db');

module.exports = async (req, res) => {
  const {
    body: {
      authors, content, signature, embeddedData, citations,
    },
  } = req;
  // Check author signature
  if (!verifySignature({
    authors, content, signature, embeddedData,
  })) {
    res.status(403).end();
    return;
  }

  // Compute content hash
  const data = {
    authors, content, signature, embeddedData, citations,
  };
  const hash = objectHash({
    authors, content, signature, embeddedData,
  });
  console.log('write', hash);
  console.log(data);

  // Store content
  await forum.put(hash, data);

  // Return hash
  res.send(hash);
};
